proc kreuzl {x y phi {noiselevel 0.1}} {
	set imgsize 300
	set armsize 20
	set maxdev 2.0
	set pi 3.14159265358979323

	set result {}
	for {set i 0} {$i<100} {incr i} {
		if {rand()<$noiselevel} {
			lappend result [expr {$imgsize*rand()}] [expr {$imgsize*rand()}]
		} else {
			set nphi [expr {$phi+int(rand()*4)*$pi/2}]
			set dev [expr {$maxdev*2*(rand()-0.5)}]
			set length [expr {$armsize*rand()}]
			lappend result [expr {$x+$length*cos($nphi)-$dev*sin($nphi)}]
			lappend result [expr {$y+$length*sin($nphi)+$dev*cos($nphi)}]
		}
	}
	return $result
}

proc save {kreuzdata fn} {
	set fd [open $fn w]
	foreach {x y} $kreuzdata {
		puts $fd "[format %.1f $x]\t[format %.1f $y]"
	}
	close $fd
}

proc make_dataset {prefix} {
	# create twenty files to test precision
	set x0 120.1
	set y0 50.3
	set phi0 0.2

	for {set i 0} {$i<20} {incr i} {
		save [kreuzl $x0 $y0 $phi0 0.5] $prefix[format %02d $i].dat
		set x0 [expr {$x0+2.1}]
		set y0 [expr {$y0+9.4}]
		set phi0 [expr {$phi0+0.01}]
	}
}
